set DIR=%JAVA6_HOME%
if "%DIR%"=="" set DIR=%JAVA_HOME%
if not "%DIR%"=="" set DIR=%DIR%\bin\

"%DIR%java" -version 2> java.version.txt
more java.version.txt | findstr /I /C:"1.6"
if errorlevel 1 (
    echo Expected JAVA_6. > compilation.log
    exit 0
)

if not exist "%~n1.java" (
    copy %1 "%~n1.java"
)

set name=%~n1

if "%name%"=="CheckerRunner" (
    echo Class name CheckerRunner is reserved. Please, use another. > compilation.log
    exit 0
)

del /F /Q %name%.class
del /F /Q %name%.jar

for %%i in (*.jar) do (
    "%DIR%jar" -x < %%i
)

move CheckerRunner.java._ CheckerRunner.java

set testlib4j=1

if not exist testlib4j.jar (
    set testlib4j=0 
)

more %1 | findstr /I /C:"ru.ifmo.testlib"
if errorlevel 1 (
    set testlib4j=0 
)

if "%testlib4j%"=="1" (
    "%DIR%java" -jar ReplaceAll.jar CheckerRunner.java CHECKER_CLASS_NAME %name%
) else (
    del /F /Q CheckerRunner.java
)

del /F /Q *.jar

for %%i in (*.java) do (
    "%DIR%javac" -cp ".;*" %%i 2>> compilation.log
    if errorlevel 1 (
        exit 1
    )
)

if exist %name%.class (
    echo Manifest-Version: 1.0> MANIFEST.MF
    echo Created-By: Invoker>> MANIFEST.MF
    
    more %1 | findstr /I /C:"ru.ifmo.testlib"
    if errorlevel 1 (
        echo Main-Class: %name%>> MANIFEST.MF
    ) else (
        echo Main-Class: CheckerRunner>> MANIFEST.MF
    )
    
    "%DIR%jar" -cvfm %name%.jar MANIFEST.MF *
)

del /F /Q *.class
