#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
using namespace std;
const double eps = 1e-10;

bool cmp_angle(const pair<double, double>& p1, const pair<double, double>& p2) {
	return atan2(p1.second, p1.first) < atan2(p2.second, p2.first) - eps;
}

bool cmp_equal(const pair<double, double>& p1, const pair<double, double>& p2) {
	return fabs(atan2(p1.second, p1.first) - atan2(p2.second, p2.first)) < eps;
}

int main() {
    freopen("cake.in","r",stdin);
    freopen("cake.out","w",stdout);

	int n, r, cx, cy, px, py;
	vector< pair<double, double> > res;
	scanf("%d%d%d%d", &n, &r, &cx, &cy);
	for (int i = 0; i < n; ++i) {
		scanf("%d%d", &px, &py);
		px -= cx, py -= cy;
		if ((px != 0) || (py != 0)) {
			double len = sqrt(px * (double) px + py * (double) py);
			res.push_back(make_pair(px / len * r, py / len * r));
			res.push_back(make_pair(-px / len * r, -py / len * r));
		}
	}
	res.push_back(make_pair(r, 0));
	res.push_back(make_pair(-r, 0));
	res.push_back(make_pair(0, r));
	res.push_back(make_pair(0, -r));
	sort(res.begin(), res.end(), cmp_angle);
	res.resize(unique(res.begin(), res.end(), cmp_equal) - res.begin());
	printf("%d\n", (int) res.size());
	for (int i = 0; i < (int) res.size(); ++i)
		printf("%.6lf %.6lf\n", cx + res[i].first, cy + res[i].second);
	return 0;
}