//	#pragma comment(linker, "/STACK:60000000")
#include <iostream>
#include <cstdio>
#include <cmath>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <cassert>
#include <algorithm>
#include <vector>
#include <set>
#include <string>

#define pb push_back
#define mp make_pair
#define fs first
#define sc second
#define len(x) (int((x).size()))
#ifdef LOCALD
#define eprintf(...) fprintf(stderr, __VA_ARGS__)
#else
#define eprintf(...) {}
#endif

#ifdef __linux__
#define I64d "%lld"
#define I64u "%llu"
#else
#define I64d "%I64d"
#define I64u "%I64u"
#endif

typedef long long int int64;
typedef long double ext;

const int inf = 1000000000;


using namespace std;

const int maxk = 1001;
const int maxf = 5;

const int mod = 1000000009;

int d[maxk][maxf];    	    
int n, f;

int64 kk;

int tests;

int main()
{
	assert(freopen("solitaire.in", "rt", stdin));
	assert(freopen("solitaire.out", "wt", stdout));
	#ifdef LOCALD
    assert(freopen("debug.txt", "wt", stderr));
    #endif
    scanf("%d", &tests);
    for (int test = 0; test < tests; test++){
	    scanf("%d %d"I64u, &n, &f, &kk);
	    n++;
	    if (n == 1){
	    	printf("NO\n");
	    	continue;
	    }
	    
	    for (int i = 0; i <= f; i++)
	    	d[1][i] = 1;
		
		for (int i = 2; i < maxk; i++)
			for (int j = 0; j <= f; j++){
				d[i][j] = inf;
				if (j > 0)
					d[i][j] = min(d[i][j], d[i - 1][j - 1]);
				for (int x = 1; 2 * x <= i; x++)
					d[i][j] = min(d[i][j], max(d[x][j] + 1, d[i - x][j] + 1));			
				eprintf("D[%d][%d] = %d\n", i, j, d[i][j]);				
			}    	
			
		int k = 1;
		while (d[k][f] + 1 <= n){
			k++;
			assert(k < maxk);
		}	
		printf("%s\n", k - 1 >= kk - 1 ? "YES" : "NO");
	}
    return 0;
}
