/*
    Modes:
    pyramid => like a pyramid :)
    rectangle  => c[i] == const or c[i] == 0
    rand => random
	maxanswer => for each output (l, r) : l == r
	antiqsort => antiqsort test
	2pyramids
	2towers
*/

#include "testlib.h"
#include <iostream>
#include <sstream>

using namespace std;

int s2i(const string &s)
{
    stringstream ss;
    ss << s;
    int x;
    ss >> x;
    return x;
}

int a[200001], c[200001];

void shuffle(int n) {
	for (int i = 0; i < n; i++) {
		swap(a[i], a[rnd.next(n)]);
	}
}
void print(int n) {
	printf("%d\n", n);
	for (int i = 0; i < n - 1; i++) {
		printf("%d ", a[i]);
	}
	printf("%d\n", a[n - 1]);
}

int main(int argc, char *argv[])
{
    registerGen(argc, argv);

    string mode = argv[1];
    int n = s2i(argv[2]), l = s2i(argv[3]), r = s2i(argv[4]);

    if (mode == "pyramid") {
		int x = l + 1 + rnd.next(r - l - 1);
		for(int i = l; i <= r; i++) {
			c[i]++;
			n--;
		}
		for(int i = 0; i < n; i++) {
			c[rnd.next(l, r)]++;
		}
		sort(c + l, c + x);
		sort(c + x, c + r + 1);
		reverse(c + x, c + r + 1);
		int k = 0;
		for (int i = l; i <= r; i++) {
			for (int j = 0; j < c[i]; j++) {
				a[k++] = i;
			}
		}
		shuffle(k);
		print(k);
	} 
	if (mode == "rectangle") {
		int k = 0;
		for	(int i = l; i <= r; i++) {
			for	(int j = 0; j < n / (r - l + 1); j++)
				a[k++] = i;
		}
		shuffle(k);
		print(k);
	}
	if (mode == "rand") {
		for	(int i = 0; i < n; i++) {
			a[i] = rnd.next(l, r);
		}
		print(n);
	}
	if (mode == "maxanswer") {
		for	(int i = 0; i <= n; i++) {
			c[i]++;
		}
		for (int i = 0; i < r - l - 2 * n; i++) {
			c[rnd.next(n + 1)]++;
		}
		int k = 0, s = l;
		for(int i = 0; i < n; i++) {
			s += c[i];
			a[k++] = s++;
		}
		shuffle(k);
		print(k);
	}
	if (mode == "antiqsort") {
		a[1] = 1;
		a[2] = 3; 
		a[3] = 2;

		for (int i = 4; i <= n; i++) {
			a[i] = a[(i + 1) / 2];
			a[(i + 1) / 2] = i;
		}
		for (int i = 0; i < n; i++) {
			a[i] = a[i + 1];
		}
		print(n);
	}
	if (mode == "2pyramids") {
		n /= 2;
		int h = int(sqrt(n));
		for(int i = l, j = h; j > 0; i--, j--) {
			c[i] = j;
		}
		for(int i = l, j = h; j > 0; i++, j--) {
			c[i] = j;
		}
		for(int i = r, j = h; j > 0; i--, j--) {
			c[i] = j;
		}
		for(int i = r, j = h; j > 0; i++, j--) {
			c[i] = j;
		}
		int k = 0;
		for (int i = l - h + 1; i < r + h; i++) {
			for (int j = 0; j < c[i]; j++) {
				a[k++] = i;
			}
		}		
		shuffle(k);
		print(k);
	}
	if (mode == "2towers") {
		c[l] = n / 4;
		c[r] = n / 4;
		n = n - 2 * (n / 4);
		for	(int i = 0; i < n; i++) {
			c[rnd.next(l + 1, r - 1)]++;
		}
		int k = 0;
		for (int i = l; i <= r; i++) {
			for (int j = 0; j < c[i]; j++) {
				a[k++] = i;
			}
		}		
		shuffle(k);
		print(k);
	}
	

    return 0;
}
