#include "testlib.h"
#include <cctype>
using namespace std;

#define MAX_PRIME 10000000
#define LEFT_BORDER 1

int prime_pref[MAX_PRIME + 1];
//amount of prime numbers on prefix [0 ; i]

void fill_primes()
{
    for (int i = 2; i <= MAX_PRIME; ++i) {
        if (prime_pref[i] == 0) {
            for (int j = i + i; j < MAX_PRIME; j += i) {
                prime_pref[j] = 1;
            }
        }
        prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
    }
}

int main(int argc, char* argv[])
{
    registerTestlibCmd(argc, argv);
    fill_primes();
    
    int test_n = inf.readInt();
    for (int t = 0; t < test_n; ++t) {
        int len = inf.readInt(),
                quest = inf.readInt();
        int ans_left = 0, ans_right = 0;
        int ouf_left = 0, ouf_right = 0;
        ans_left = ans.readInt();
        if (ans_left != -1) {
            ans_right = ans.readInt();
        }
        ouf_left = ouf.readInt();
        if (ouf_left != -1) {
            ouf_right = ouf.readInt();
            if (ouf_right - ouf_left + 1 != len
            || ouf_left < 1
            || ouf_right > MAX_PRIME) {
                quitf(_wa, "incorrect segment on request #%d", t);
            }
            if (prime_pref[ouf_right] - prime_pref[ouf_left - 1] != quest) {
                quitf(_wa, "wrong number of primes on request #%d", t);
            }
        } else if (ans_left != -1) {
            quitf(_wa, "wrong answer on request #%d. Answer exists endeed", t);
        }       
    }    
    quitf(_ok,"ok");
    return 0;
}