#include <iostream>
#include <cstdio>
#include <vector>
#include <cassert>
#include <algorithm>
#include <utility>
#include <string>
using namespace std;

// takes string with parametrs of len_steps.
/*
mode:
	--normal	just generates the test
	--random 	shuffles requests after generation
	--full		expands requests number to MAX_REQUEST_N
*/

#define MIN_REQUEST 7000
#define MAX_REQUEST 100000

#define MAX_REQUEST_N ((unsigned int)100000)

int main(int argc, char* argv[])
{
	assert(argc == 3);
	srand(239);
	ios::sync_with_stdio(false);

	int len_min, len_step, len_max;
	assert(sscanf(argv[1], "%d:%d:%d", &len_min, &len_step, &len_max) == 3);
	assert(len_step > 0);
	assert(len_min > 0);

	
	vector <pair <int, int> > quests(0);

	for (int len = len_min; len <= len_max; len += len_step) {
		quests.push_back(make_pair(len, MIN_REQUEST));
		quests.push_back(make_pair(len, len));
	}

	if (string(argv[2]) == "--random") {
		random_shuffle(quests.begin(), quests.end());
	}else if (string(argv[2]) == "--full") {
		int prev_n = quests.size();
		assert(prev_n > 0);
		while (quests.size() < MAX_REQUEST_N) {
			quests.push_back(quests[rand() % prev_n]);
		}
	} else if (string(argv[2]) != "--normal") {
		assert(string(argv[2]) != "--normal");
	}

	int n = min(quests.size(), MAX_REQUEST_N);
        cout << n << endl;
	for (int i = 0; i < n; ++i) {
		cout << quests[i].first << " " << quests[i].second << endl;
	}

	return 0;
}