#include <iostream>
#include <cstdio>
using namespace std;

#define MAX_LEN 100000
#define MIN_LEN 1
#define MAX_PRIME 10000000

int prime_pref[MAX_PRIME + 10];
//amount of prime numbers on prefix [0 ; i]

void fill_primes()
{
	for (int i = 2; i <= MAX_PRIME; ++i) {
		if (prime_pref[i] == 0) {
			for (int j = i + i; j <= MAX_PRIME; j += i) {
				prime_pref[j] = 1;
			}
		}
		prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
	}
}

int main(void)
{
        freopen("primes.in", "r", stdin);
	freopen("primes.out", "w", stdout);
	
	ios::sync_with_stdio(false);
	int test_n = 0;
	fill_primes();

	int window_len = 0,
		needed_k = 0;
	cin >> test_n;
	for (int t = 0; t < test_n; ++t) {
		cin >> window_len >> needed_k;

		int l_bound = 2,
			r_bound = MAX_PRIME - window_len + 1,
			middle = 0, cnt = 0;

		while (l_bound < r_bound) {
			middle = (l_bound + r_bound) / 2;
			int cnt = prime_pref[middle + window_len - 1] - prime_pref[middle - 1];
			if (cnt > needed_k) {
				l_bound = middle + 1;
			} else {
				r_bound = middle;
			}
		}
		if (prime_pref[l_bound + window_len - 1] - prime_pref[l_bound - 1] == needed_k) {
			cout << l_bound << " " << l_bound + window_len - 1 << endl;
		} else {
			cout << -1 << endl;
		}
	}
	return 0;
}