#include <cstdio>
#include <iostream>
using namespace std;

#define MAX_LEN 100000
#define MIN_LEN 1
#define MAX_PRIME 10000000

int prime_pref[MAX_PRIME + 10];
//amount of prime numbers on prefix [0 ; i]

void fill_primes()
{
	for (int i = 2; i <= MAX_PRIME; ++i) {
		if (prime_pref[i] == 0) {
			for (int j = i + i; j <= MAX_PRIME; j += i) {
				prime_pref[j] = 1;
			}
		}
		prime_pref[i] = prime_pref[i - 1] + !prime_pref[i];
	}
}

int main(void)
{
	freopen("primes.in", "r", stdin);
	freopen("primes.out", "w", stdout);
	ios::sync_with_stdio(false);
	int test_n = 0;
	fill_primes();

	int len = 0,
		needed_k = 0;
	cin >> test_n;
	for (int t = 0; t < test_n; ++t) {
		cin >> len >> needed_k;

		int ans = -1;
		for (int x = 2; x + len - 1 <= MAX_PRIME; ++x) {
			if (prime_pref[x + len - 1] - prime_pref[x - 1] == needed_k) {
				ans = x;
				break;
			}
		}
		if (ans == -1) {
			cout << -1 << endl;
		} else {
			cout << ans << " " << ans + len - 1 << endl;
		}
	}
	return 0;
}
