#include <cstdio>
#include <cassert>
#include <deque>
#include <vector>
#include <queue>
#include <algorithm>
using namespace std;

const int M = 10500;

char ans[M];
int anspt = 0;

const int N = 27;
bool F[N][N];

int vx[] = {1, 0, -1, 0}, vy[] = {0, -1, 0, 1};
char L[] = "RULD";

int it = 0;
int was[N][N];
int D[N][N];
int p[N][N];

#define eprintf(...) fprintf(stderr, __VA_ARGS__)

deque<pair<int, int> > Q;

int n, m;

int ay, ax;

void go(int d)
{
    ans[anspt++] = L[d];
    pair<int, int> tl = Q.back();
    Q.pop_back();
    F[tl.first][tl.second] = 0;
    pair<int, int> hd = Q.front();
    hd.first += vy[d], hd.second += vx[d];
    F[hd.first][hd.second] = 1;
    Q.push_front(hd);
    if (F[ay][ax])
        Q.push_back(tl), F[tl.first][tl.second] = 1;
}

queue<pair<int, int> > QQ;

bool BFS(int sy, int sx, int ty, int tx)
{
    ++it;
    D[sy][sx] = 0;
    p[sy][sx] = -1;
    was[sy][sx] = it;
    while (!QQ.empty())
        QQ.pop();
    QQ.push(make_pair(sy, sx));
    while (!QQ.empty())
    {
        int y = QQ.front().first, x = QQ.front().second;
        QQ.pop();
        if (y == ty && x == tx)
            break;
        for (int v = 0; v < 4; v++)
        {
            int ry = y + vy[v], rx = x + vx[v];
            if (was[ry][rx] == it || F[ry][rx])
                continue;
            was[ry][rx] = it;
            p[ry][rx] = v;
            QQ.push(make_pair(ry, rx));
        }
    }
    return (was[ty][tx] == it);
}

int cur = 0;

int rndmove()
{
    pair<int, int> hd = Q.front();
    pair<int, int> tl = Q.back();
    vector<int> V;
    for (int v = 0; v < 4; v++)
    {
        pair<int, int> t = make_pair(hd.first + vy[v], hd.second + vx[v]);
        if (!F[t.first][t.second] || t == tl)
            V.push_back(v);
    }
    if (V.empty())
        return 2; // =(
    else
    {
        while (find(V.begin(), V.end(), cur) == V.end())
            cur = (cur + 1) & 3;
        return cur;
    }
}

int main()
{
    int n, m;
    scanf("%d %d", &n, &m);
    for (int i = 0; i <= n + 1; i++)
        F[i][0] = F[i][m + 1] = 1;
    for (int i = 0; i <= m + 1; i++)
        F[0][i] = F[n + 1][i] = 1;
    
    Q.push_front(make_pair(1, 1));
    Q.push_front(make_pair(1, 2));
    Q.push_front(make_pair(1, 3));
    F[1][1] = F[1][2] = F[1][3] = 1;
    while (true)
    {
        scanf("%d %d", &ay, &ax);
        if (ay == 0 && ax == 0)
            break;
        anspt = 0;
        while (!BFS(Q.front().first, Q.front().second, ay, ax))
            go(rndmove());

        vector<int> W;
        for (pair<int, int> pr(ay, ax); pr != Q.front(); pr = make_pair(pr.first + vy[2 ^ p[pr.first][pr.second]], pr.second + vx[2 ^ p[pr.first][pr.second]]))
            W.push_back(p[pr.first][pr.second]);
        for (int i = (int)W.size() - 1; i >= 0; i--)
            go(W[i]);

        ans[anspt] = 0;
        printf("%s\n", ans);
        fflush(stdout);
    }
    return 0;
}
